import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type HarvestSwapParamsStruct = {
    path: PromiseOrValue<string>[];
    min: PromiseOrValue<BigNumberish>;
    deadline: PromiseOrValue<BigNumberish>;
    pathData: PromiseOrValue<BytesLike>;
};
export type HarvestSwapParamsStructOutput = [
    string[],
    BigNumber,
    BigNumber,
    string
] & {
    path: string[];
    min: BigNumber;
    deadline: BigNumber;
    pathData: string;
};
export interface ILevConvexInterface extends utils.Interface {
    functions: {
        "closePosition()": FunctionFragment;
        "collateralBalance()": FunctionFragment;
        "collateralToUnderlying()": FunctionFragment;
        "convexRewardPool()": FunctionFragment;
        "deposit(uint256)": FunctionFragment;
        "getAndUpdateTVL()": FunctionFragment;
        "getDepositAmnt(uint256)": FunctionFragment;
        "getMaxTvl()": FunctionFragment;
        "getTotalTVL()": FunctionFragment;
        "getWithdrawAmnt(uint256)": FunctionFragment;
        "harvest((address[],uint256,uint256,bytes)[])": FunctionFragment;
        "redeem(uint256,address)": FunctionFragment;
        "underlying()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "closePosition" | "collateralBalance" | "collateralToUnderlying" | "convexRewardPool" | "deposit" | "getAndUpdateTVL" | "getDepositAmnt" | "getMaxTvl" | "getTotalTVL" | "getWithdrawAmnt" | "harvest" | "redeem" | "underlying"): FunctionFragment;
    encodeFunctionData(functionFragment: "closePosition", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateralBalance", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateralToUnderlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "convexRewardPool", values?: undefined): string;
    encodeFunctionData(functionFragment: "deposit", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getAndUpdateTVL", values?: undefined): string;
    encodeFunctionData(functionFragment: "getDepositAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getMaxTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getTotalTVL", values?: undefined): string;
    encodeFunctionData(functionFragment: "getWithdrawAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "harvest", values: [HarvestSwapParamsStruct[]]): string;
    encodeFunctionData(functionFragment: "redeem", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    decodeFunctionResult(functionFragment: "closePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralToUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "convexRewardPool", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getAndUpdateTVL", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDepositAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalTVL", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getWithdrawAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "harvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    events: {
        "AdjustLeverage(uint256)": EventFragment;
        "Deposit(address,uint256)": EventFragment;
        "HarvestedToken(address,uint256,uint256)": EventFragment;
        "Redeem(address,uint256)": EventFragment;
        "SetVault(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "AdjustLeverage"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Redeem"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetVault"): EventFragment;
}
export interface AdjustLeverageEventObject {
    newLeverage: BigNumber;
}
export type AdjustLeverageEvent = TypedEvent<[
    BigNumber
], AdjustLeverageEventObject>;
export type AdjustLeverageEventFilter = TypedEventFilter<AdjustLeverageEvent>;
export interface DepositEventObject {
    sender: string;
    amount: BigNumber;
}
export type DepositEvent = TypedEvent<[string, BigNumber], DepositEventObject>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
    amountUnderlying: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface RedeemEventObject {
    sender: string;
    amount: BigNumber;
}
export type RedeemEvent = TypedEvent<[string, BigNumber], RedeemEventObject>;
export type RedeemEventFilter = TypedEventFilter<RedeemEvent>;
export interface SetVaultEventObject {
    vault: string;
}
export type SetVaultEvent = TypedEvent<[string], SetVaultEventObject>;
export type SetVaultEventFilter = TypedEventFilter<SetVaultEvent>;
export interface ILevConvex extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ILevConvexInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        closePosition(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        collateralBalance(overrides?: CallOverrides): Promise<[BigNumber]>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<[BigNumber]>;
        convexRewardPool(overrides?: CallOverrides): Promise<[string]>;
        deposit(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getAndUpdateTVL(overrides?: CallOverrides): Promise<[BigNumber]>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getMaxTvl(overrides?: CallOverrides): Promise<[BigNumber]>;
        getTotalTVL(overrides?: CallOverrides): Promise<[BigNumber]>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        harvest(swapParams: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        redeem(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
    };
    closePosition(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    collateralBalance(overrides?: CallOverrides): Promise<BigNumber>;
    collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
    convexRewardPool(overrides?: CallOverrides): Promise<string>;
    deposit(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getAndUpdateTVL(overrides?: CallOverrides): Promise<BigNumber>;
    getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
    getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    harvest(swapParams: HarvestSwapParamsStruct[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    redeem(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    underlying(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        closePosition(overrides?: CallOverrides): Promise<BigNumber>;
        collateralBalance(overrides?: CallOverrides): Promise<BigNumber>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        convexRewardPool(overrides?: CallOverrides): Promise<string>;
        deposit(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getAndUpdateTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        harvest(swapParams: HarvestSwapParamsStruct[], overrides?: CallOverrides): Promise<BigNumber[]>;
        redeem(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "AdjustLeverage(uint256)"(newLeverage?: null): AdjustLeverageEventFilter;
        AdjustLeverage(newLeverage?: null): AdjustLeverageEventFilter;
        "Deposit(address,uint256)"(sender?: null, amount?: null): DepositEventFilter;
        Deposit(sender?: null, amount?: null): DepositEventFilter;
        "HarvestedToken(address,uint256,uint256)"(token?: null, amount?: null, amountUnderlying?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: null, amount?: null, amountUnderlying?: null): HarvestedTokenEventFilter;
        "Redeem(address,uint256)"(sender?: null, amount?: null): RedeemEventFilter;
        Redeem(sender?: null, amount?: null): RedeemEventFilter;
        "SetVault(address)"(vault?: PromiseOrValue<string> | null): SetVaultEventFilter;
        SetVault(vault?: PromiseOrValue<string> | null): SetVaultEventFilter;
    };
    estimateGas: {
        closePosition(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        collateralBalance(overrides?: CallOverrides): Promise<BigNumber>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        convexRewardPool(overrides?: CallOverrides): Promise<BigNumber>;
        deposit(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getAndUpdateTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        harvest(swapParams: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        redeem(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        closePosition(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        collateralBalance(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        convexRewardPool(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        deposit(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getAndUpdateTVL(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getDepositAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMaxTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalTVL(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getWithdrawAmnt(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        harvest(swapParams: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        redeem(amount: PromiseOrValue<BigNumberish>, to: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
